{% comment %}
Copyright 2016 Mattia Basaglia

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}
{% load simple_page %}

<section>
<header>{% section h2 %}Output Formats{% endsection %}</header>
<p>Each API method supports the following formats:</p>
<table>
    <tr><th>Extenstion</th><th>MIME Type<th>Name</th></tr>
    {% for ext, format in api.response_types.iteritems %}
        <tr><td class="fixed_string">{{ ext }}</td>
            <td class="fixed_string">{% eval "format.mime_type" %}</td>
            <td>{% eval "format.human_name" %}</td></tr>
    {% endfor %}
</table>
<p>The <span class="fixed_string">json</span> and
<span class="fixed_string">xml</span> formats support pretty printing,
based on the the presence of the paramter <span class="fixed_string">pretty</span>
in the query string.
</section>

<section>
<header>{% section h2 %}Error Responses{% endsection %}</header>
<p>In case of an error, the response will be a dictionary containing
the key <span class="fixed_string">error</span>, mapping to an error message.</p>
<p>And the returned response will have an apporiate HTTP status code.</p>
</section>

<section>
<header>{% section h2 %}Methods{% endsection %}</header>
<p>This section displays all of the supported API methods.
For presentation, the <span class="fixed_string">json</span> is used, but all
of the <a href="#output-formats">formats mentioned above</a> are supported.</p>

{% section h3 %}GET{% endsection %}

{% section h4 class="section api_url_section" id="api-version" %}version.json{% endsection %}
{% api_url_link "api:version" type="json" %}
<p>Returns the API version (The current version is {{ api.version }}).</p>

{% section h4 class="section api_url_section" id="api-characters" %}characters.json{% endsection %}
{% api_url_link "api:characters" "?pretty" type="json" %}
<p>Returns a list of characters, including all of their basic properties.</p>

{% section h4 class="section api_url_section" id="api-character" %}characters/<em>Name</em>.json{% endsection %}
{% api_url_link "api:character" "?pretty" name="Twilight Sparkle" type="json" %}
<p>Returns detailed information on the given character.</p>

{% section h4 class="section api_url_section" id="api-character-id" %}characters/id/<em>ID</em>.json{% endsection %}
{% api_url_link "api:character_by_id" "?pretty" id="2" type="json" %}
<p>Returns detailed information on the given character (from its numeric ID).</p>

{% section h4 class="section api_url_section" id="api-episodes" %}episodes.json{% endsection %}
{% api_url_link "api:episodes" "?pretty" type="json" %}
<p>Returns a list with all of the episodes.</p>

{% section h4 class="section api_url_section" id="api-season" %}episodes/<em>Season</em>.json{% endsection %}
{% api_url_link "api:season" "?pretty" season="01" type="json" %}
<p>Returns a list with all of the episodes in the given season.</p>

{% section h4 class="section api_url_section" id="api-episode" %}episodes/<em>Season</em>/<em>Episode</em>.json{% endsection %}
{% api_url_link "api:episode" "?pretty" season="01" number="01" type="json" %}
<p>Returns detailed information on the given episode.</p>

{% section h4 class="section api_url_section" id="api-episode-lines" %}episodes/<em>Season</em>/<em>Episode</em>/lines.json{% endsection %}
{% api_url_link "api:lines" "?pretty" season="01" number="01" type="json" %}
<p>Returns transcript data for the given episode.</p>
</section>
